Attribute VB_Name = "ExitWin"
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!
Option Explicit

Private Declare Function SetSystemTime Lib "kernel32" ( _
                         lpSystemTime As SYSTEMTIME) As Long
                         
Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" _
                         Alias "LookupPrivilegeValueA" ( _
                         ByVal lpSystemName As String, _
                         ByVal lpName As String, _
                         lpLuid As LARGE_INTEGER) As Long
                         
Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" ( _
                         ByVal TokenHandle As Long, _
                         ByVal DisableAllPrivileges As Long, _
                         NewState As TOKEN_PRIVILEGES, _
                         ByVal BufferLength As Long, _
                         PreviousState As TOKEN_PRIVILEGES, _
                         ReturnLength As Long) As Long
                         
Private Declare Function OpenProcessToken Lib "advapi32.dll" ( _
                         ByVal ProcessHandle As Long, _
                         ByVal DesiredAccess As Long, _
                         TokenHandle As Long) As Long
                         
Private Declare Function ExitWindowsEx Lib "user32" ( _
                         ByVal uFlags As Long, _
                         ByVal dwReserved As Long) As Long
                         
Private Declare Function InitiateSystemShutdown Lib "advapi32.dll" _
                         Alias "InitiateSystemShutdownA" ( _
                         ByVal lpMachineName As String, _
                         ByVal lpMessage As String, _
                         ByVal dwTimeout As Long, _
                         ByVal bForceAppsClosed As Long, _
                         ByVal bRebootAfterShutdown As Long) As Long
                         
Private Declare Function GetVersionEx Lib "kernel32" _
                         Alias "GetVersionExA" ( _
                         lpVersionInformation As OSVERSIONINFO) As Long
                         
Public Const ANYSIZE_ARRAY = 1
Public Const TOKEN_ADJUST_PRIVILEGES = 32
Public Const TOKEN_QUERY = 8
Public Const SE_PRIVILEGE_ENABLED As Long = 2
Public Const EWX_LOGOFF = 0
Public Const EWX_SHUTDOWN = 1
Public Const EWX_REBOOT = 2
Public Const EWX_FORCE = 4
Public Const SE_SHUTDOWN_NAME = "SeShutdownPrivilege"
Public Const SE_REMOTE_SHUTDOWN_NAME = "SeRemoteShutdownPrivilege"

Private Const SE_SYSTEMTIME_NAME = "SeSystemtimePrivilege"

Public Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Public Type LUID_AND_ATTRIBUTES
    pLuid As LARGE_INTEGER
    Attributes As Long
End Type

Public Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
End Type

Private Type OSVERSIONINFO ' fr den Aufruf des GetVersionEx-API
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Function SetTime(Datum As Date) As Boolean

    Dim ret As Long
    Dim hToken As Long
    Dim tkp As TOKEN_PRIVILEGES
    Dim tkpOld As TOKEN_PRIVILEGES
    Dim fOk As Boolean
    Dim Time As SYSTEMTIME
    
    ' berprfen, ob Window NT ausgefhrt wird.
    If IsWindowsNT() Then
    
        ' Windows NT wird ausgefhrt.
        ' Sicherheitsberprfungen und
        ' Vernderungen sind jetzt notwendig,
        ' um sicherzustellen, da das Token
        ' vorhanden ist, das einen Neustart zult.
        If OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, _
            hToken) Then
            
            ret = LookupPrivilegeValue(vbNullString, SE_SYSTEMTIME_NAME, tkp.Privileges( _
                0).pLuid)
                
            tkp.PrivilegeCount = 1
            tkp.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
            fOk = AdjustTokenPrivileges(hToken, 0, tkp, LenB(tkpOld), tkpOld, ret)
        End If
    Else
    
        ' Win95/98 wird ausgefhrt. Keine Aktion ist notwendig.
        fOk = True
    End If
    
    If fOk Then
        Time.wSecond = Val(Format(Datum, "ss"))
        
        Time.wMinute = Val(Mid(Format(Datum, "long time"), InStr(Format(Datum, "long " & _
            "time"), ":") + 1))
            
        Time.wHour = Val(Format(Datum, "hh")) - 1
        Time.wDay = Val(Format(Datum, "d"))
        Time.wMonth = Val(Format(Datum, "m"))
        Time.wYear = Val(Format(Datum, "yyyy"))
        SetTime = (SetSystemTime(Time) <> 0)
    End If
End Function

Public Function SystemDown() As Boolean
    Dim ret As Long
    Dim hToken As Long
    Dim tkp As TOKEN_PRIVILEGES
    Dim tkpOld As TOKEN_PRIVILEGES
    Dim fOKRunterfahren As Boolean
    
    Const sSHUTDOWN As String = SE_SHUTDOWN_NAME
    
    ' berprfen, ob Windows NT ausgefhrt wird.
    If IsWindowsNT() Then
    
        ' Windows NT wird ausgefhrt.
        ' Sicherheitsberprfungen und
        ' Vernderungen sind jetzt notwendig,
        ' um sicherzustellen, da das Token
        ' vorhanden ist, das einen Neustart zult.
        If OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, _
            hToken) Then
            
            ret = LookupPrivilegeValue(vbNullString, sSHUTDOWN, tkp.Privileges(0).pLuid)
            tkp.PrivilegeCount = 1
            tkp.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
            
            fOKRunterfahren = AdjustTokenPrivileges(hToken, 0, tkp, LenB(tkpOld), _
                tkpOld, ret)
        End If
    Else
        ' Win95/98 wird ausgefhrt. Keine Aktion ist notwendig.
        fOKRunterfahren = True
    End If
    
    If fOKRunterfahren Then
        SystemDown = (ExitWindowsEx(EWX_SHUTDOWN, 0) <> 0)
    End If
End Function

' -----------------------------------------------------------
' FUNKTION: IsWindowsNT
'
' Liefert "True", falls dieses Programm unter
' Windows NT ausgefhrt wird.
' -----------------------------------------------------------
'
Public Function IsWindowsNT() As Boolean
    Const dwMaskNT = &H2&
    IsWindowsNT = (GetWinPlatform() And dwMaskNT)
End Function

' ----------------------------------------------------------
' FUNKTION: GetWinPlatform
' Aktuelle Windows-Plattform ermitteln.
' ---------------------------------------------------------
Public Function GetWinPlatform() As Long
    Dim osvi As OSVERSIONINFO
    
    osvi.dwOSVersionInfoSize = Len(osvi)
    
    If GetVersionEx(osvi) = 0 Then
        Exit Function
    End If
    
    GetWinPlatform = osvi.dwPlatformId
End Function
